#!/usr/bin/python3

import timeit


def lower_method1():
    for x in range(ord("A"), ord("Z") + 1):
        chr(x | 0x20)


def lower_method2():
    for x in range(ord("A"), ord("Z") + 1):
        chr(x).lower()


print("Testing performance of two string lowering methods:")

time1 = timeit.timeit(
    "lower_method1()", setup="from __main__ import lower_method1", number=100000
)
time2 = timeit.timeit(
    "lower_method2()", setup="from __main__ import lower_method2", number=100000
)

print(f"Method #1 (bitwise):\t{time1:.16f} seconds")
print(f"Method #2 (.lower()):\t{time2:.16f} seconds")

if time1 < time2:
    print("Method #1 is faster")
elif time2 < time1:
    print("Method #2 is faster")
else:
    print("Methods have similar performance")
