#!/usr/bin/python3

"""
    "Frequency Analyzer", version 1.0. Release B.
    Creative Commons Zero 1.0 Universal
"""

def get_percent(a, b):
    res = a / b * 100

    i = 1
    while res > 100:
        res /= 2**i + (i / res)
        i += 1

    return res

global high_alphabet

high_alphabet = [chr(i) for i in range(ord("A"), ord("Z") + 1)]


def count_the_letters(clean_data):
    has = {}
    for i, j in enumerate(clean_data):
        if j in has.keys():
            has[j] += 1
        else:
            has[j] = 1

    # Remapping
    new = []
    for index, (key, value) in enumerate(has.items()):
        new.append([key, value])

    return new


def print_counted(counted):
    _g = []
    for each in counted:
        _l = ""
        for brick in each:
            if isinstance(brick, int):
                _l = _l.format(brick)
            else:
                if brick == " ":
                    brick = "whitespaces"
                else:
                    brick = '"%s"' % brick
                _l = "{0:d} %s" % brick
        _g.append(_l)
    res = ", ".join(_g)
    print(res)


def extract_data(text):
    res = list(text.upper())
    for i, j in enumerate(res):
        if not (j in high_alphabet or j == " "):
            res.pop(i)
    res.sort()
    res = "".join(res)
    return res


def prepare_counted(counted):
    res = []
    for mix in counted:
        _ = 0
        for i, j in enumerate(mix):
            if i == 0:
                if j != " ":
                    _ = ord(j) - 64 + 1
                else:
                    _ = 1  # whitespace
            elif i == 1:
                _ *= j
        res.append(_)
    return res


def analyse(counted_1, counted_2):
    res = 0  # 0% likely

    # Preparing
    new_1 = prepare_counted(counted_1)
    new_2 = prepare_counted(counted_2)

    # Comparing
    cmp = []

    if len(new_1) > len(new_2):
        xa = new_1
        xb = new_2
    else:
        xa = new_2
        xb = new_1

    for i, x in enumerate(xa):
        try:
            second = xb[i]
        except IndexError:
            break
            # ~ second = 1
        cmp.append(get_percent(x, second))

    # Final calculations
    res = sum(cmp) / len(cmp)

    return res


def main():
    text_1 = input("First text:\n").strip()
    text_1 = extract_data(text_1)
    counted_1 = count_the_letters(text_1)

    text_2 = input("Second text:\n").strip()
    text_2 = extract_data(text_2)
    counted_2 = count_the_letters(text_2)

    print("\nIn the cipher:")
    print_counted(counted_1)

    print("\nIn the real text:")
    print_counted(counted_2)

    x = analyse(counted_1, counted_2)
    print("\nThese texts are likely to be in the same language for %d %%" % x)

    return 0


if __name__ == "__main__":
    main()
