#!/usr/bin/python3

import os
import random

# Generate a random seed using os.urandom
seed = int.from_bytes(os.urandom(8), byteorder="big")

# Seed the random number generator with the random seed
random.seed(seed)

# Define the Myers-Briggs personality types and their traits
mbti_types = [
    ("ISTJ", ["practical", "fact-oriented", "decisive", "organized", "responsible"]),
    ("ISFJ", ["supportive", "loyal", "practical", "empathetic", "organized"]),
    ("INFJ", ["insightful", "visionary", "empathetic", "principled", "decisive"]),
    ("INTJ", ["strategic", "analytical", "independent", "logical", "reserved"]),
    ("ISTP", ["logical", "practical", "independent", "adventurous", "hands-on"]),
    ("ISFP", ["sensitive", "harmonious", "adventurous", "creative", "reserved"]),
    ("INFP", ["idealistic", "compassionate", "creative", "curious", "adaptable"]),
    ("INTP", ["analytical", "logical", "independent", "curious", "objective"]),
    ("ESTP", ["bold", "pragmatic", "energetic", "direct", "observant"]),
    ("ESFP", ["fun-loving", "spontaneous", "outgoing", "generous", "optimistic"]),
    ("ENFP", ["enthusiastic", "spontaneous", "imaginative", "curious", "empathetic"]),
    ("ENTP", ["clever", "imaginative", "resourceful", "curious", "adaptable"]),
    ("ESTJ", ["efficient", "practical", "organized", "responsible", "decisive"]),
    ("ESFJ", ["friendly", "responsible", "warm", "organized", "loyal"]),
    ("ENFJ", ["charismatic", "compassionate", "insightful", "empathetic", "decisive"]),
    ("ENTJ", ["strategic", "logical", "assertive", "independent", "decisive"]),
]

# Generate and print a random MBTI type and its typical and non-typical traits
mbti_type, traits = random.choice(mbti_types)
typical_traits = ", ".join(traits)
non_typical_traits = ", ".join(random.sample(traits, k=5))
print(f"Random MBTI type: {mbti_type}")
print(f"Typical traits: {typical_traits}")
print(f"Non-typical traits: {non_typical_traits}")
