#!/usr/bin/python3

import random
import re

regex_word = re.compile(r"\b\w+\b")


def permute_string_words(text):
    words = re.findall(regex_word, text)
    modified_words = []

    for word in words:
        if len(word) > 3:
            first_letter = word[0]
            last_letter = word[-1]
            middle_letters = word[1:-1]
            middle_letters_list = list(middle_letters)
            random.shuffle(middle_letters_list)
            shuffled_middle_letters = "".join(middle_letters_list)
            modified_word = first_letter + shuffled_middle_letters + last_letter
            modified_words.append(modified_word)
        else:
            modified_words.append(word)

    modified_text = re.sub(regex_word, lambda m: modified_words.pop(0), text)
    return modified_text


if __name__ == "__main__":
    print(permute_string_words(input()))
