#!/usr/bin/python3

from random import randint as rand


def old_gen(word_combination):
    case = [
        "{s}²",
        "Uber {s}",
        "Uber-{s}",
        "Über{s}",
        "{s}{t}",
        "{s}-{s}",
        "Super {s}",
        "Hypo{s}",
        "Hyper{s}",
        "A{s}",
        "Geo{s}",
        "Re{s}",
        "New {s}",
        "{s}++",
        "0x{s}",
        "${t}",
        "xXx -=*[{s}]*=- xXx",
        ">>> {s}",
        "%{s}%",
        "{s} is done by {r} %",
        "Orto{t}",
    ]

    result = ""
    for x in case:
        result += (
            x.format(
                s=word_combination,
                t=word_combination.lower(),
                r=word_combination.lower().capitalize(),
            )
            + "\n"
        )
    return result[:-1]


def new_gen(parts_count=2):
    result = ""
    prefix = [
        "a",
        "an",
        "amphi",
        "ana",
        "anti",
        "apo",
        "ap",
        "cata",
        "cat",
        "dia",
        "di",
        "dis",
        "ec",
        "ex",
        "en",
        "em",
        "el",
        "endo",
        "ento",
        "end",
        "ent",
        "epi",
        "ep",
        "eu",
        "ev",
        "exo",
        "ecto",
        "hyper",
        "hypo",
        "hyp",
        "meta",
        "met",
        "palin",
        "para",
        "par",
        "peri",
        "pro",
        "pros",
        "syn",
        "sym",
        "syl",
        "sy",
        "aqua",
        "hydro",
        "geo",
        "orto",
        "re",
        "neo",
        "electro",
        "octo",
        "quadro",
        "tri",
        "mono",
        "uni",
        "poly",
        "decem",
        "pauci",
        "multi",
        "pluri",
        "deuter",
        "prot",
        "septi",
        "myria",
        "milli",
        "macro",
        "demi",
        "semi",
        "ico",
        "sa",
        "sympho",
        "synchro",
        "chrono",
        "epo",
        "co",
        "bi",
        "non",
        "phys",
        "quasi",
        "caco",
    ]
    roots = [
        "gen",
        "oxide",
        "onym",
        "bio",
        "chemo",
        "info",
        "ling",
        "pass",
        "psycho",
        "mnemo",
        "lexo",
        "log",
        "phobo",
        "philo",
        "phibi",
        "qui",
        "quo",
        "sophy",
        "vita",
        "edron",
        "angle",
        "aedr",
        "andro",
        "medi",
        "sonic",
        "melo",
        "aud",
        "audi",
    ]
    suffix = [
        "s",
        "ium",
        "ion",
        "ition",
        "on",
        "onth",
        "bis",
        "sh",
        "e",
        "y",
        "pro",
        "el",
        "en",
        "er",
        "nics",
        "ism",
        "ist",
        "cs",
        "ive",
        "ic",
        "dian",
        "ics",
        "tics",
        "log",
        "logy",
        "nom",
        "nomy",
        "metr",
        "metry",
    ]
    scheme = ""
    scheme_gen = {
        1: "R",
        2: "PR",
        3: "PRS",
        4: "RR",
        5: "PRR",
        6: "PPRR",
        7: "RRS",
        8: "RRSS",
        9: "PPRRS",
        10: "PPRRSS",
        None: "",
    }

    if parts_count < 0:
        for i in range(0, abs(parts_count)):
            x = rand(0, 2)
            if x == 0:
                scheme += "P"
            elif x == 1:
                scheme += "R"
            elif x == 2:
                scheme += "S"
    else:
        scheme = scheme_gen.get(parts_count, "")

    for element in scheme:
        if element == "P":  # prefix
            grnd = rand(0, len(prefix) - 1)
            result += prefix[grnd]
        elif element == "R":
            grnd = rand(0, len(roots) - 1)
            result += roots[grnd]
        elif element == "S":
            grnd = rand(0, len(suffix) - 1)
            result += suffix[grnd]
    result = result.replace("csi", "xi").replace("loi", "li").replace("stc", "")
    return result


if __name__ == "__main__":
    print("Logic:")
    for i in range(0, 2**6):
        print(i + 1, new_gen(rand(1, 4)))
    print("Random:")
    for i in range(0, 2**6):
        print(i + 1, new_gen(rand(2, 4) * -1))
